// TFT LCD(ST7735)̕\eXgTvQ
// MLA(Microchip Libraries for Applications)Framework/hfileiohg܂B
// PIC24EP256MC202/MPLAB X v5.15/XC16 v1.30 ł̃RpCłB
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
// __delay_ms/__delay_usׂ̈ɕKv
#define FCY 60000000UL             // Fosc/2(60MIPS)
#include <libpic30.h>

#include "skST7735x.h"
#include "skST7735x_img.h"

// RtBM[V̐ݒ
// FICD
#pragma config ICS    = PGD1       // In-Circuit Debuggers̒ʐM`ĺiPGEC1PGED1ŒʐM܂)
#pragma config JTAGEN = OFF        // JTAG ͎gpȂ
// FPOR
#pragma config ALTI2C1 = ON        // I2C1ŎgpśAASDA1/ASCL1gp
#pragma config ALTI2C2 = ON        // I2C2ŎgpśAASDA2/ASCL2gp
#pragma config WDTWIN  = WIN25     // EIb`hbO25%EChËƂ
// FWDT
#pragma config WDTPOST = PS32768   // Watchdog Timer Postscaler bits (1:32,768)
#pragma config WDTPRE  = PR128     // Watchdog Timer Prescaler bit (1:128)
#pragma config PLLKEN  = ON        // PLLbN܂őҋ@APLLNbN֐؂芷܂
#pragma config WINDIS  = OFF       // EIb`hbOɃEChE͎gȂ
#pragma config FWDTEN  = OFF       // EIb`hbO̗L/"SWDTEN"rbgōs
// FOSC
#pragma config POSCMD   = NONE     // OIV[^̓샂[h̑I (OIV[^͎gȂ)
#pragma config OSCIOFNC = ON       // OSC2s@\̑I (OSC2s̓fW^I/OƂ)
#pragma config IOL1WAY  = OFF      // Ӌ@̃st͉xłύXolɋ
#pragma config FCKSM    = CSDCMD   // NbN̊ĎNbNؑւ͂Ȃ
// FOSCSEL
#pragma config FNOSC   = FRCPLL    // IV[^PLL삳
#pragma config PWMLOCK = ON        // PWM Lock Enable bit (Certain PWM registers may only be written after key sequence)
#pragma config IESO    = OFF       // FosĉQiK؂ւł̋N͂Ȃ
// FGS
#pragma config GWRP = OFF          // General Segment Write-Protect bit (General Segment may be written)
#pragma config GCP  = OFF          // General Segment Code-Protect bit (General Segment Code protect is Disabled)

uint16_t kanji_dt[]={0x4D45,0x403A,0x244E,0x4B53,0x3840,0} ;   // "d̖r"

int main(void)
{
     int ans ;
     
     ///////////////////////////////////////////////////////////////////////////
     // MCȔlݒs                                             //
     ///////////////////////////////////////////////////////////////////////////
     _SWDTEN = 0 ;                 // EIb`hbO͖
     // VXeNbN̐ݒ(Fosc=120MHz FCY=60MHz/60MIPS)
     // Fosc=FRC*(M/(N1*N2))  M=PLLDIV+2  N1=PLLPRE+2  N2=2*(PLLPOST+1)
     // Fosc=7.37*(65/(2*2))=119.7625(120MHz)  FCY=120/2=60MIPS
     _FRCDIV  = 0b000 ;            //  FRC|XgXP[(ȂF7.37MHz)
     _PLLPRE  = 0b00000 ;          // PLL̓̓vXP[[N1=2](QF7.37/2=3.685MHz)
     _PLLDIV  = 63 ;               // PLL̃tB[hobNl[M=65]
     _PLLPOST = 0b00 ;             // PLL̏o̓|XgXP[[N2=2](Ȃ)
     // Wait for PLL to lock
     while (OSCCONbits.LOCK!= 1) ;
     // I/O̐ݒ
     ANSELA = 0b0000000000000000 ; // AN0,1AiO͎gpȂAfW^I/OɊ
     ANSELB = 0b0000000000000000 ; // AN2-5AiO͎gpȂAfW^I/OɊ
     TRISA  = 0b0000000000000000 ; // RA0-RA4Sďo͂ɐݒA1œ 0ŏo
     TRISB  = 0b0000001000000000 ; // RB9(SDI1)͓́Ȃ͏o͂ɐݒ
     PORTA  = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     PORTB  = 0b0100000001000000 ; // o̓s̏,SD_CS(B6),LCD_CS(B14)HIGH,LOWɂ
     // S̊荞݂̋ݒ
     _IPL     = 0 ;                // CPŮݗD惌xݒ(D惌xOȏ)
     _GIE     = 1 ;                // S荞ݏ

     // fBXvCW[̏s
     // TFT LCD 1.8C` 18rbgJ[ 128x160hbg (΃^uV[)
     LCD_begin(CHIP_ST7735X | DISPLAY_TYPE_1,BLACK_SCREEN) ;
     LCD_ColorSet(63,63,63) ;      // F
     LCD_Puts(0,0,"test start") ;

     __delay_ms(3000) ;       // 3bɊJn

     // C[Wo͊֘Ȁs
     ans = IMG_imgInit() ;         // SDJ[h̏
     if (ans != 0) {
          LCD_Puts(0,10,"imgInit Failure!") ;
          while(1) ;               // I(J[h̏ɎsASDĂȂ)
     }

     // BMPt@CSDǂݏoĕ`s
     ans = IMG_PutImage(0,0,"EBINE.BMP") ;
     if (ans == 1) LCD_Puts(0,0,"File open error!") ;
     if (ans == 2) LCD_Puts(0,0,"No BMP file! or No 24Color!") ;
     // ̕\
     LCD_ColorSet(63,63,63) ;      // F
     IMG_PutsK(45,115,(uint16_t *)kanji_dt) ;

     IMG_imgEnd() ;                // SDJ[h̏I

     ///////////////////////////////////////////////////////////////////////////
     // C̃[v                                                    //
     ///////////////////////////////////////////////////////////////////////////
     while(1) {
     }
}
